diff -aur --exclude='*.beam' --exclude=configure --exclude=Makefile otp_src_R9C-0/lib/erl_interface/src/legacy/erl_marshal.c otp_src_R9C-0.fixed/lib/erl_interface/src/legacy/erl_marshal.c
--- otp_src_R9C-0/lib/erl_interface/src/legacy/erl_marshal.c	2003-08-13 00:24:38.000000000 +0200
+++ otp_src_R9C-0.fixed/lib/erl_interface/src/legacy/erl_marshal.c	2003-08-21 16:36:11.000000000 +0200
@@ -1512,7 +1512,7 @@
     case ERL_SMALL_TUPLE_EXT:
       i = *(*e1)++; 	j = *(*e2)++;
       if (i < j) return -1;
-      if (j > j ) return 1;
+      if (i > j ) return 1;
       while (i--) {
 	if ((j = compare_top_ext(e1, e2))) return j;
       }
@@ -1523,7 +1523,7 @@
       j = (**e2 << 24) | ((*e2)[1]) << 16| ((*e2)[2]) << 8| ((*e2)[3]) ;	
       *e2 += 4;
       if (i < j) return -1;
-      if (j > j ) return 1;
+      if (i > j ) return 1;
       while (i--) {
 	if ((j = compare_top_ext(e1, e2))) return j;
       }
@@ -1604,6 +1604,9 @@
     ei_free_big(b1);
     ei_free_big(b2);
 
+    *e1 += i1;
+    *e2 += i2;
+
     return res;
 }
 
@@ -1621,6 +1624,9 @@
     
     f1 = l1;
 
+    *e1 += i1;
+    *e2 += i2;
+
     return cmp_floats(f1,f2);
 }
 
@@ -1651,6 +1657,9 @@
     
     ei_free_big(b2);
 
+    *e1 += i1;
+    *e2 += i2;
+
     return cmp_floats(f1,f2);
 }
 
@@ -1661,14 +1670,15 @@
 
     i1 = i2 = 0;
     if ( ei_decode_long(*e1,&i1,&l1) < 0 ) {
-        fprintf(stderr,"Failed to decode 1\r\n");
         return -1;
     }
     if ( ei_decode_long(*e2,&i2,&l2) < 0 ) {
-        fprintf(stderr,"Failed to decode 2\r\n");
         return 1;
     }
-    
+
+    *e1 += i1;
+    *e2 += i2;
+
     if ( l1 < l2 ) return -1;
     else if ( l1 > l2 ) return 1;
     else return 0;
@@ -1682,7 +1692,10 @@
     i1 = i2 = 0;
     if ( ei_decode_double(*e1,&i1,&f1) < 0 ) return -1;
     if ( ei_decode_double(*e2,&i2,&f2) < 0 ) return 1;
-    
+
+    *e1 += i1;
+    *e2 += i2;
+
     return cmp_floats(f1,f2);
 }
 
@@ -1709,6 +1722,9 @@
     ei_free_big(b1);
     ei_free_big(b2);
 
+    *e1 += i1;
+    *e2 += i2;
+
     return res;
 }
 
